import 'package:cryptography/cryptography.dart';
import 'package:test/test.dart';
import 'package:ticket/ticket.dart';

void main() {
  group('SGen', () {
    test('Generates valid unsigned Stubs', () {
      final gen = SGen(keyPair: null, hashAlgorithm: blake2b);
      expect(
          gen.generate(
              payload: 536,
              error: false,
              transactionIdentifier: [0, 1, 2, 3, 4, 5]).isValidSync(),
          equals(true));
    });

    test('Generates valid signed Stubs', () {
      final gen =
          SGen(hashAlgorithm: blake2b, keyPair: ed25519.newKeyPairSync());
      expect(
          gen.generate(
              payload: 536,
              error: false,
              transactionIdentifier: [0, 1, 2, 3, 4, 5]).isValidSync(),
          equals(true));
    });
  });
}
