import 'dart:convert';

import 'package:ticket/ticket.dart';
import 'package:test/test.dart';

void main() {
  group('StubInfoBody', () {
    StubInfoBody infoBody;

    setUp(() {
      infoBody = StubInfoBody([0, 0, 0, 0, 0, 0], null, false);
    });

    test('toMap()', () {
      expect(
          infoBody.toMap(),
          equals({
            'transactionIdentifier': infoBody.transactionIdentifier,
            'payload': infoBody.payload,
            'error': infoBody.error
          }));
    });

    test('fromMap()', () {
      expect(
          StubInfoBody.fromMap({
            'transactionIdentifier': infoBody.transactionIdentifier,
            'payload': infoBody.payload,
            'error': infoBody.error
          }),
          equals(infoBody));
    });

    test('toJson()', () {
      expect(infoBody.toJson(), equals(jsonEncode(infoBody.toMap())));
    });

    test('fromJson()', () {
      expect(StubInfoBody.fromJson(infoBody.toJson()), equals(infoBody));
    });

    group('.isValid()', () {
      test('returns true for good input', () {
        expect(infoBody.isValid(), equals(true));
      });

      group('returns false', () {
        test('when error is null', () {
          expect(StubInfoBody([0, 0, 0, 0, 0, 0], null, null).isValid(),
              equals(false));
        });

        test('when the transactionIdentifier is short', () {
          expect(StubInfoBody([0, 0, 0, 0, 0], null, false).isValid(),
              equals(false));
        });
      });
    });
  });
}
